module syncronizer #(parameter P_SIGNAL_WIDTH = 1,
							parameter P_NUMBER_OF_STAGES = 2,
							parameter P_REGISTERED_INPUT = "NO")
						(	input i_new_clock,
							input i_old_clock,
							input  [P_SIGNAL_WIDTH-1:0] i_signal,
							output [P_SIGNAL_WIDTH-1:0] o_syncronized_signal
							);

							
							
// Input old domain register - 
generate if (P_REGISTERED_INPUT=="YES") begin
reg [P_SIGNAL_WIDTH-1:0] r_syncr_old_clock;
always @(posedge i_old_clock)
	r_syncr_old_clock <= i_signal;
end endgenerate		
					
// First Stage
reg [P_SIGNAL_WIDTH-1:0] r_syncr_new_clock  [P_NUMBER_OF_STAGES-1:0];
always @(posedge i_new_clock)
	r_syncr_new_clock[0] <= (P_REGISTERED_INPUT=="YES") ? r_syncr_old_clock : i_signal;

// Second and subsequent N Stages
generate if (P_NUMBER_OF_STAGES>=2) begin
	integer h;								
	always @(posedge i_new_clock)
	for (h =(P_NUMBER_OF_STAGES-1) ; h >= 1 ; h=h-1)
		r_syncr_new_clock[h] <= r_syncr_new_clock[h-1];
end endgenerate

assign o_syncronized_signal = r_syncr_new_clock[P_NUMBER_OF_STAGES-1];
							
endmodule
							